/*
Push & Wind Animations
Original Code by DirkTheHusky (banned)
Super Sprite fixes by Icezer (banned)
New Wind Frames code by Fav (hi!! that's me!!! :D)
*/

freeslot("S_PLAY_PUSH", "SPR2_PUSH")

states[S_PLAY_PUSH] = {
	sprite = SPR_PLAY,
	frame = SPR2_PUSH,
	tics = 4,
	nextstate = S_PLAY_WALK,
}

addHook("PlayerThink", do
	for player in players.iterate
		if player.mo and player.mo.valid
		and (player.mo.skin == "gemma") then
			//Push Frames
			if player.pushtimer == nil
				player.pushtimer = 0
			end
						
			if player.pushtimer < 1
				player.pushtimer = 0
			end
			if player.pushtimer > 3
				player.pushtimer = 3
			end
			
			if player.powers[pw_pushing] < 2
			and not player.pushobject
				player.pushtimer = 0
			end
			if (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_PUSH)
				if P_IsObjectOnGround(player.mo)
					if player.powers[pw_pushing] >= 2
						player.pushtimer = $1 + 1
					else
						player.pushtimer = $1 - 1
					end
					if player.pushtimer > 2
					and player.powers[pw_pushing]
						player.mo.state = S_PLAY_PUSH
						player.mo.frame = ((leveltime / 13) % 4)
						if player.powers[pw_super]
							player.mo.frame = $|FF_FULLBRIGHT
						end
					end
				end
			else
				player.pushtimer = 0
			end
		end
	end
end)

//Push function for Pushable Objects

local function pushtrigger(mo, push)
	local player = mo.player
	
	if (push.z > (mo.z + mo.height))
	or (mo.z > (push.z + push.height)) then
		return
	end
	
	if (mo.skin == "gemma") then
		if push.flags & MF_PUSHABLE then
			if mo.state == S_PLAY_PUSH
				mo.tics = 7
			end
			if push.momx and push.momy
				player.drawangle = R_PointToAngle2(0, 0, push.momx, push.momy)
			end
			if mo.state == S_PLAY_PUSH then
				mo.frame = ((leveltime / 13) % 4)
				if mo.player.powers[pw_super]
					mo.frame = $|FF_FULLBRIGHT
				end
			end
			if mo.state == S_PLAY_WALK then
				mo.state = S_PLAY_PUSH
			end
		end
	end
end

addHook("MobjCollide", pushtrigger, MT_PLAYER)
addHook("MobjMoveCollide", pushtrigger, MT_PLAYER)

//Wind Frames

freeslot("S_PLAY_WIND", "SPR2_WIND")
states[S_PLAY_WIND] = {SPR_PLAY, SPR2_WIND, 2, nil, 0, 0, S_PLAY_WIND}
addHook("PlayerThink", function(player) 
    if not (player.mo and player.mo.valid and player.mo.skin == "gemma") return end
    if player.fanobj == nil
    or (P_PlayerInPain(player)) 
    or player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_DEAD or player.mo.state == S_PLAY_ROLL
    or player.powers[pw_carry]
    or P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
        player.fanobj = false
    end
	if player.twirl_angle == nil then player.twirl_angle = 1 end

    if player.mo.state == S_PLAY_WIND and not (player.powers[pw_carry] == CR_DUSTDEVIL)
        player.twirl_angle = $+ANG15
        player.drawangle = player.twirl_angle
    end
end)
addHook("ThinkFrame", do
    for player in players.iterate 
        if not (player.mo and player.mo.valid and player.mo.skin == "gemma") return end
        
        if player.powers[pw_carry] == CR_DUSTDEVIL
        and (player.mo.sprite2 == SPR2_PAIN or player.powers[pw_super])
        or P_PlayerTouchingSectorSpecial(player, 4, 5) and (player.mo.sprite2 == SPR2_FALL or player.powers[pw_super])
        or player.fanobj and (player.mo.sprite2 == SPR2_FALL or player.powers[pw_super])
            player.mo.state = S_PLAY_WIND
        end
    end
end)
addHook("MobjMoveCollide", function(thing, tmthing)
    if thing and thing.valid and thing.player and thing.skin == "gemma"
    and tmthing and tmthing.valid and tmthing.type == MT_FAN
    and tmthing.z - thing.z <= thing.health << FRACBITS
        thing.player.fanobj = true
    end
end, MT_PLAYER)